package com.iRecruit.config;

import java.net.URI;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Random;

import javax.servlet.http.HttpServletRequest;

import org.json.JSONObject;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.web.client.HttpStatusCodeException;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.util.UriComponentsBuilder;



public class Utility {
	
	public static String generatorOTP(int length) 
	  { 
	    Random obj = new Random(); 
	    String OTP = "";
	    for (int i=0; i<length; i++) 
	    { 
	    	OTP += (char)(obj.nextInt(10)+48); 
	    } 
	    return OTP; 
	  } 
	public static ResponseEntity proxyPostRequest(String body,HttpServletRequest request,JSONObject newHeaders) throws Exception{
		String requestUrl = request.getRequestURI();
		
		//System.out.println(request.getServerName()+"   "+request.getLocalAddr());
	    URI uri = new URI("http", null, request.getServerName(), request.getServerPort(), null, null, null);
	    uri = UriComponentsBuilder.fromUri(uri)
	                              .path(requestUrl)
	                              .query(request.getQueryString())
	                              .build(true).toUri();

	    HttpHeaders headers = new HttpHeaders();
	    Enumeration<String> headerNames = request.getHeaderNames();
	    while (headerNames.hasMoreElements()) {
	        String headerName = headerNames.nextElement();
	        if(newHeaders.has(headerName)) {
	        	headers.set(headerName,(String)newHeaders.get(headerName));
	        	newHeaders.remove(headerName);
	        }else {
	        	headers.set(headerName, request.getHeader(headerName));
	        }
	    }
	    Iterator<String> keys = newHeaders.keys();
	    while(keys.hasNext()) {
	    	String key = keys.next();
	    	headers.set(key, (String)newHeaders.get(key));
	    }
	    HttpEntity<String> httpEntity = new HttpEntity<>(body, headers);
	    RestTemplate restTemplate = new RestTemplate();
	    try {
	        return restTemplate.exchange(uri,HttpMethod.valueOf(request.getMethod()), httpEntity, String.class);
	    } catch(HttpStatusCodeException e) {
	        return ResponseEntity.status(e.getRawStatusCode())
	                             .headers(e.getResponseHeaders())
	                             .body(e.getResponseBodyAsString());
	    }
	}
}
