package com.iRecruit.exception;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ResponseStatus;

import lombok.Getter;
import lombok.Setter;

@ResponseStatus(value = HttpStatus.NOT_FOUND)
@Getter
@Setter
public class InvalidArgument extends RuntimeException {
	private String message;

    public InvalidArgument( String message) {
        super(String.format("%s",message));
        this.message = message;
    }
}