package com.iRecruit.exception;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ResponseStatus;

@ResponseStatus(value = HttpStatus.NOT_FOUND)
public class InvalidOTPOrRef extends RuntimeException {
    private String userID;
    private String OTP;

    public InvalidOTPOrRef( String userId, String OTP) {
        super(String.format("%s is not valid OTP for %s", OTP, userId));
        this.userID = userId;
        this.OTP = OTP;
    }
}