package com.iRecruit.modules.auth.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

@Service("smsService")
public class SMSService 
{

    @Value("${spring.sms.url}")
    private String smsURL;
    
    
    RestTemplate restTemplate = new RestTemplate();
    
    public String sendSMS(List<Long> mobileNumber,String message) {
    	
    	return this.restTemplate.getForObject(smsURL, String.class);
    }
}
