package com.iRecruit.modules.auth.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.iRecruit.modules.auth.model.AuditLogs;
import com.iRecruit.modules.auth.payload.AuditLogsDto;
import com.iRecruit.modules.auth.repository.AuditLogsRepository;
import com.iRecruit.modules.auth.service.AuditLogsService;

@Service
public class AuditLogsServiceImpl implements AuditLogsService {

	@Autowired
    private AuditLogsRepository auditLogsRepository;
	
	@Override
	public AuditLogs save(AuditLogsDto auditLogsDto) {
		return auditLogsRepository.save(new AuditLogs(auditLogsDto));
	}

}
