// Yashvant Calculation Of NGPA To NGPL Based On Request From Front End - 4 Apr 2020 
// Exception Handled Using JSONException Feature
package com.iRecruit.modules.auth.service.impl;

import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.google.gson.JsonObject;
import com.iRecruit.constant.LeaderCalcConfig;
import com.iRecruit.constant.TemplateConfig;
import com.iRecruit.exception.ResourceNotFoundException;
import com.iRecruit.modules.auth.controller.LeaderCalc;
import com.iRecruit.modules.auth.service.FycMappingService;
import com.iRecruit.modules.auth.service.LeaderCalcService;
import com.iRecruit.modules.auth.service.NGPACalcService;
import com.iRecruit.constant.LeaderCalcConfig;



import com.iRecruit.modules.auth.service.NGPAtoNGPLCalcService;
@Service
public class NGPAtoNGPLCalcServiceImpl implements NGPAtoNGPLCalcService {

	@Autowired
	LeaderCalcConfig leaderCalcConfig;
	int i,j,counter;
	double basicDoubleOperation;
	String basicStringOperation;
	String[] basicStringArrayOperation = {"Year_1","Year_2","Total"};
	String[] basicStringArrayOperation1 = {"Year_1_NGPA","Year_1_NGPL","Year_1_Total","Year_2_4_Validated_NGPAs"};
	JSONObject basicJSONOperation = new JSONObject();
	JSONObject basicJSONOperation1 = new JSONObject();
	JSONArray basicJSONArrayOperation = new JSONArray();
	
	double fycPersantage = 25;
	final double rnrPersantageACP = 2.5;
	final double MonthlyDevelopmentBonus_Year1_NGPL_Persantage1 = 1.7;
	final double MonthlyDevelopmentBonus_Year1_NGPL_Persantage2 = 20;
	double[] MonthlyDevelopmentBonus_Year1_NGPL = {0,0,0,0};
	JSONArray MSA_Value = new JSONArray();
	
	double [][] ngpaToLeaderCareerPathTable = new double[3][2];
	double [][] metricsTable = new double[4][8];
	double[][] appointmentAndConversionTable = new double[4][2];
	double[][] earningsTable = new double[4][9];
	JSONObject Response_JSON = new JSONObject();
	
	public JSONObject calculateFYCCreditAndWFYC (String designation, Double FYC ) throws JSONException {
		//basicStringOperation = "[{\"DT\":170,\"l1\":0,\"l2\":0,\"id\":1,\"designation\":\"PBA\",\"mapping_DT_minimum_fyc\":5000},{\"DT\":170,\"l1\":30,\"l2\":10,\"id\":107,\"designation\":\"BA\",\"mapping_DT_minimum_fyc\":10000},{\"DT\":170,\"l1\":50,\"l2\":25,\"id\":109,\"designation\":\"SBA\",\"mapping_DT_minimum_fyc\":15000},{\"DT\":170,\"l1\":50,\"l2\":25,\"id\":111,\"designation\":\"CBA\",\"mapping_DT_minimum_fyc\":15000},{\"DT\":170,\"l1\":50,\"l2\":30,\"id\":113,\"designation\":\"Partner\",\"mapping_DT_minimum_fyc\":20000},{\"DT\":170,\"l1\":50,\"l2\":30,\"id\":115,\"designation\":\"Senior_Partner\",\"mapping_DT_minimum_fyc\":20000},{\"DT\":170,\"l1\":0,\"l2\":10,\"id\":118,\"designation\":\"PBA\",\"mapping_DT_minimum_fyc\":5000}]";
		basicJSONArrayOperation = leaderCalcConfig.getValue("mpb");
        for( i=0;i<basicJSONArrayOperation.length();i++ ) {
            basicJSONOperation = new JSONObject();
            basicJSONOperation = basicJSONArrayOperation.getJSONObject(i);
            if( basicJSONOperation.getString("designation").equalsIgnoreCase(designation) ) {
                break;
            }
        }
		basicJSONOperation1.put("WFYC",0);
		if( FYC >= basicJSONOperation.getDouble("mapping_DT_minimum_fyc") ) {
			basicJSONOperation1.put("WFYC", Math.round( ( basicJSONOperation.getDouble("DT") * FYC ) / 100 ) );
		}
		basicJSONOperation1.put("DT",basicJSONOperation.getDouble("DT"));
		return basicJSONOperation1;
	}
	
	public double calculateMonthlyPerformanceBonus ( Double WFYC ) throws JSONException {
		basicDoubleOperation = 0;
	//	basicStringOperation = ;
		basicJSONArrayOperation = leaderCalcConfig.getValue("fyc");
		for ( i = 0; i < basicJSONArrayOperation.length(); i++ ) {
			if (WFYC >= basicJSONArrayOperation.getJSONObject(i).getDouble("minval") && WFYC <= basicJSONArrayOperation.getJSONObject(i).getDouble("maxval")) {
				basicDoubleOperation = Math.round( ( WFYC * basicJSONArrayOperation.getJSONObject(i).getDouble("per") ) / 100 );
			}
		}
		return basicDoubleOperation;
	}

	public void preparengpaToLeaderCareerPathTable(JSONObject requestJSON) throws JSONException {
		// Preparing Leader Career Path Table 
		for(i=0;i<2;i++) {
			basicJSONOperation = new JSONObject();
			basicJSONOperation = requestJSON.getJSONObject("NGPA_To_Leader_Career_Path").getJSONObject("Year_"+(i+1));
			ngpaToLeaderCareerPathTable[i][0] = basicJSONOperation.getDouble("Conversion_To_Leader_In_Mth");
			ngpaToLeaderCareerPathTable[i][1] = basicJSONOperation.getDouble("No_Of_Agents_Referred_Recruit");
		}
		ngpaToLeaderCareerPathTable[2][0] = ngpaToLeaderCareerPathTable[0][0] + ngpaToLeaderCareerPathTable[1][0];
		ngpaToLeaderCareerPathTable[2][1] = ngpaToLeaderCareerPathTable[0][1] + ngpaToLeaderCareerPathTable[1][1];
	}
	
	public void preparemetricsTable(JSONObject requestJSON) throws JSONException {
		// Preparing Metrics Table 
		for(i=0;i<4;i++) {
			basicJSONOperation = new JSONObject();
			if( i == 0 ) {
				basicJSONOperation = requestJSON.getJSONObject("Metrics_MeetingConversion_Earnings").getJSONObject("Year_1_NGPA");
			}
			else if ( i == 1 ) {
				basicJSONOperation = requestJSON.getJSONObject("Metrics_MeetingConversion_Earnings").getJSONObject("Year_1_NGPL");
			}
			else if ( i == 3 ) {
				basicJSONOperation = requestJSON.getJSONObject("Metrics_MeetingConversion_Earnings").getJSONObject("Year_2_4_Validated_NGPAs");
			}
			if ( i != 2 ) {
				basicDoubleOperation = ( ( i == 0 ) ? ngpaToLeaderCareerPathTable[0][0] : ( ( i == 1 ) ? ( 12 - ngpaToLeaderCareerPathTable[0][0] + 3 ) : 0 ) ) ;
				metricsTable[i][0] = basicDoubleOperation;
				metricsTable[i][1] = ( basicJSONOperation.getString("Validations_Met").equalsIgnoreCase("Yes") ? 1 : 0 );
				metricsTable[i][2] = basicJSONOperation.getDouble("Customer_Appointments");
				metricsTable[i][3] = basicJSONOperation.getDouble("Customer_Meetings");
				metricsTable[i][4] = basicJSONOperation.getDouble("Conversion_(NOP#)");
				metricsTable[i][5] = basicJSONOperation.getDouble("Case_Size_(INR)");
				metricsTable[i][6] = metricsTable[i][4] * metricsTable[i][5];
			}
			else {
				basicStringOperation = requestJSON.getString("Total_Validations_Met");
				metricsTable[i][1] = ( basicStringOperation.equalsIgnoreCase("Yes") ? 1 : 0 );
				metricsTable[i][2] = metricsTable[0][2] + metricsTable[1][2];
				metricsTable[i][3] = metricsTable[0][3] + metricsTable[1][3];
				metricsTable[i][4] = metricsTable[0][4] + metricsTable[1][4];
				metricsTable[i][6] = metricsTable[0][6] + metricsTable[1][6];
				metricsTable[i][5] = Math.round( metricsTable[i][6] / metricsTable[i][4] );
			}
			metricsTable[i][7] = Math.round( ( metricsTable[i][6] * requestJSON.getDouble("Eligible_Premium") ) / 12 );
		}
	}
	
	public void prepareappointmentAndConversionTable(JSONObject requestJSON) throws JSONException {
		// Preparing Appointment And Conversion Table
		for(i=0;i<4;i++) {
			appointmentAndConversionTable[i][0] = Math.round( ( metricsTable[i][3] / metricsTable[i][2] ) * 100 );
			appointmentAndConversionTable[i][1] = Math.round( ( metricsTable[i][4] / metricsTable[i][3] ) * 100 );
		}
	}
	
	public void prepareearningsTable(JSONObject requestJSON) throws JSONException {
		// Preparing Earnings Table
	//	basicStringOperation = "[{\"180000\":25000,\"360000\":25000,\"720000\":25000,\"1440000\":25000,\"MPB\":2},{\"180000\":25000,\"360000\":50000,\"720000\":50000,\"1440000\":50000,\"MPB\":3},{\"180000\":25000,\"360000\":50000,\"720000\":75000,\"1440000\":75000,\"MPB\":4},{\"180000\":25000,\"360000\":50000,\"720000\":75000,\"1440000\":100000,\"MPB\":5}]";
		basicJSONArrayOperation = leaderCalcConfig.getValue("mdb");
		for( i=0;i<basicJSONArrayOperation.length();i++ ) {
			if ( basicJSONArrayOperation.getJSONObject(i).getDouble("MDB") == 4 ) {
				basicJSONOperation1 = basicJSONArrayOperation.getJSONObject(i);
				break;
			}
		}
		for( i=0;i<4;i++ ) {
			if( metricsTable[i][7] > 180000 && metricsTable[i][7] < 360000 ) {
				MonthlyDevelopmentBonus_Year1_NGPL[i] = basicJSONOperation1.getDouble("monthly_ep_18");
			} else if ( metricsTable[i][7] > 360000 && metricsTable[i][7] < 720000 ) {
				MonthlyDevelopmentBonus_Year1_NGPL[i] = basicJSONOperation1.getDouble("monthly_ep_36");
			} else if ( metricsTable[i][7] > 720000 && metricsTable[i][7] < 1400000 ) {
				MonthlyDevelopmentBonus_Year1_NGPL[i] = basicJSONOperation1.getDouble("monthly_ep_72");
			} else if ( metricsTable[i][7] > 1400000 ) {
				MonthlyDevelopmentBonus_Year1_NGPL[i] = basicJSONOperation1.getDouble("monthly_ep_144");
			}
		}		
		
		basicJSONOperation = MSA_Value.getJSONObject(0);
		basicStringOperation = requestJSON.getString("FS_Type");
		basicDoubleOperation = basicJSONOperation.getDouble(basicStringOperation);
		earningsTable[0][0] = Math.round( ( metricsTable[0][6] * requestJSON.getDouble("Commission_Rate") ) / 100 );
		
		basicJSONOperation1 = new JSONObject();
		basicJSONOperation1 = calculateFYCCreditAndWFYC("BA",earningsTable[0][0]);
		earningsTable[0][7] = basicJSONOperation1.getDouble("DT");
		earningsTable[0][8] = basicJSONOperation1.getDouble("WFYC");
		
		earningsTable[0][1] = Math.round( ( metricsTable[0][0] * basicDoubleOperation ));
		earningsTable[0][2] = Math.round( ( metricsTable[0][6] * rnrPersantageACP ) / 100 );
		earningsTable[0][3] = 0;
		earningsTable[0][4] = 0;
		earningsTable[0][5] = earningsTable[0][0] + earningsTable[0][1] + earningsTable[0][2];
		earningsTable[0][6] = 0;
		
		earningsTable[1][0] = Math.round( ( metricsTable[1][6] * fycPersantage ) / 100 );
		
		basicJSONOperation1 = new JSONObject();
		basicJSONOperation1 = calculateFYCCreditAndWFYC("BA",earningsTable[1][0]);
		
		earningsTable[1][7] = basicJSONOperation1.getDouble("DT");
		earningsTable[1][8] = basicJSONOperation1.getDouble("WFYC");
		
		earningsTable[1][1] = 0;
		earningsTable[1][2] = 0;
		earningsTable[1][3] = ( earningsTable[1][8] != 0 ? calculateMonthlyPerformanceBonus(earningsTable[1][8]) : 0 );
		earningsTable[1][4] = Math.round( MonthlyDevelopmentBonus_Year1_NGPL[1] * ( 12 - metricsTable[0][0] ) );
		earningsTable[1][5] = earningsTable[1][3] + earningsTable[1][4];
		earningsTable[1][6] = 0;
		
		earningsTable[2][0] = earningsTable[0][0];

		basicJSONOperation1 = new JSONObject();
		basicJSONOperation1 = calculateFYCCreditAndWFYC("BA",earningsTable[2][0]);
		
		earningsTable[2][7] = basicJSONOperation1.getDouble("DT");
		earningsTable[2][8] = basicJSONOperation1.getDouble("WFYC");
		
		earningsTable[2][1] = earningsTable[0][1];
		earningsTable[2][2] = earningsTable[0][2];
		earningsTable[2][3] = earningsTable[1][3];
		earningsTable[2][4] = earningsTable[1][4];
		earningsTable[2][5] = earningsTable[2][0] + earningsTable[2][1] + earningsTable[2][2] + earningsTable[2][3] + earningsTable[2][4];
		earningsTable[2][6] = Math.round( earningsTable[2][5] / 12 );
		
		earningsTable[3][0] = Math.round( ( metricsTable[3][6] * fycPersantage ) / 100 );
		
		basicJSONOperation1 = new JSONObject();
		basicJSONOperation1 = calculateFYCCreditAndWFYC("BA",earningsTable[3][0]);
		earningsTable[3][7] = basicJSONOperation1.getDouble("DT");
		earningsTable[3][8] = basicJSONOperation1.getDouble("WFYC");
		
		earningsTable[3][1] = 0;
		earningsTable[3][2] = 0;
		earningsTable[3][3] = ( earningsTable[3][8] != 0 ? calculateMonthlyPerformanceBonus(earningsTable[3][8]) : 0 );
		earningsTable[3][4] = Math.round( ngpaToLeaderCareerPathTable[2][1] * MonthlyDevelopmentBonus_Year1_NGPL[3] * 12 );
		earningsTable[3][5] = earningsTable[3][3] + earningsTable[3][4];
		earningsTable[3][6] = Math.round( earningsTable[3][5] / 12 );
		
	}
	
	public JSONObject prepareAllFormula(JSONObject requestJSON) throws JSONException {
		
		MSA_Value= leaderCalcConfig.getValue("msa");
		preparengpaToLeaderCareerPathTable(requestJSON);
		preparemetricsTable(requestJSON);
		prepareappointmentAndConversionTable(requestJSON);
		prepareearningsTable(requestJSON);
		
		Response_JSON.put("FS_Type", requestJSON.getString("FS_Type"));
		Response_JSON.put("Total_Validations_Met", requestJSON.getString("Total_Validations_Met"));
		Response_JSON.put("Eligible_Premium", requestJSON.getDouble("Eligible_Premium"));
		Response_JSON.put("Commission_Rate", requestJSON.getDouble("Commission_Rate"));
		
		basicJSONOperation1 = new JSONObject();
		for(i=0;i<3;i++) {
			basicJSONOperation = new JSONObject();
			basicJSONOperation.put("Conversion_To_Leader_In_Mth", ngpaToLeaderCareerPathTable[i][0]);
			basicJSONOperation.put("No_Of_Agents_Referred_Recruit", ngpaToLeaderCareerPathTable[i][1]);
			basicJSONOperation1.put(basicStringArrayOperation[i], basicJSONOperation);
		}
		
		Response_JSON.put("NGPA_To_Leader_Career_Path", basicJSONOperation1);
		
		basicJSONOperation = new JSONObject();
		basicJSONOperation1 = new JSONObject();
		
		for(i=0;i<4;i++) {
			basicJSONOperation = new JSONObject();
			basicJSONOperation.put("No_Of_Months", metricsTable[i][0]);
			basicJSONOperation.put("Validations_Met", ( ( metricsTable[i][1] == 1 ) ? "Yes" : "No" ) );
			basicJSONOperation.put("Customer_Appointments", metricsTable[i][2]);
			basicJSONOperation.put("Customer_Meetings", metricsTable[i][3]);
			basicJSONOperation.put("Conversion_(NOP#)", metricsTable[i][4]);
			basicJSONOperation.put("Case_Size_(INR)", metricsTable[i][5]);
			basicJSONOperation.put("WNBP_(INR)", metricsTable[i][6]);
			basicJSONOperation.put("WNBP_(INR)@EP", metricsTable[i][7]);
			basicJSONOperation.put("Meeting_To_Appointment", appointmentAndConversionTable[i][0]);
			basicJSONOperation.put("Conversion_To_Meeting", appointmentAndConversionTable[i][1]);
			basicJSONOperation.put("FYC_@_25%", earningsTable[i][0]);
			basicJSONOperation.put("Monthly_Allowance", earningsTable[i][1] );
			basicJSONOperation.put("Quarter_&_Annual_RnR", earningsTable[i][2]);
			basicJSONOperation.put("Monthly_Performance_Bonus", earningsTable[i][3]);
			basicJSONOperation.put("Monthly_Development_Bonus", earningsTable[i][4]);
			basicJSONOperation.put("Total_Earnings", earningsTable[i][5]);
			basicJSONOperation.put("Per_Month_Earning", earningsTable[i][6]);
			basicJSONOperation.put("FYC_Credit", earningsTable[i][7]);
			basicJSONOperation.put("WFYC", earningsTable[i][8]);
			basicJSONOperation1.put(basicStringArrayOperation1[i], basicJSONOperation);
		}
		
		Response_JSON.put("Metrics_MeetingConversion_Earnings", basicJSONOperation1);
				
		basicJSONOperation = new JSONObject();
		basicJSONOperation.put("As_NGPA_Year_1", earningsTable[2][6]);
		basicJSONOperation.put("As_NGPA_Year_2", earningsTable[3][6]);
		basicJSONOperation.put("As_NGPA_Growth", Math.round( ( ( earningsTable[3][6] / earningsTable[2][6] ) - 1 ) * 100 ) );
		
		Response_JSON.put("Summary of Income",basicJSONOperation);
		
		return Response_JSON;
	}
	
	
}
