package com.iRecruit.config;

public class DataSourceContextHolder {

private static final ThreadLocal<String> contextHolder = new ThreadLocal<>();

private DataSourceContextHolder() {
    // private no-op constructor
}

public static final void setDataSourceName(final String dataSourceName) {
    
    contextHolder.set(dataSourceName);
}

public static final String getDataSourceName() {
    return contextHolder.get();
}

public static final void clearDataSourceName() {
    contextHolder.remove();
}

}