package com.iRecruit.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.iRecruit.constant.LeaderCalcConfig;
import com.iRecruit.exception.ResourceNotFoundException;

import com.iRecruit.modules.auth.model.FycMapping;

import com.iRecruit.modules.auth.payload.fycDto;

import com.iRecruit.modules.auth.repository.FycRepository;

import com.iRecruit.modules.auth.service.FycMappingService;

@Service
public class FycMappingServiceImpl implements FycMappingService {

	@Autowired
	FycRepository fycRepo;
	
	@Autowired
	LeaderCalcConfig LeaderCalcConfig;
	public FycMapping save(fycDto dto,Boolean isCreate) {
		
		if(!isCreate) {
			fycRepo.findById(dto.getId()).orElseThrow(()->new ResourceNotFoundException("fyc","key",dto.getId()));
		 }
		FycMapping fycMapping = null;
		 
	    fycMapping = new FycMapping();
	     fycMapping.setId(dto.getId());
		 fycMapping.setMaxval(dto.getMaxval());
		 fycMapping.setMinval(dto.getMival());
		 fycMapping.setPer(dto.getPer());
		 
		// DBConfig.setValue(dto.getKey(), dto.getMaxval(), dto.getMaxval(), dto.getMaxval());
		
		 
		 return fycRepo.save(fycMapping);
	
		 
	 }
	

	
	 public List<FycMapping> findAll(){
		 return fycRepo.findAll();
	 }
}
